package test;

import javax.swing.JFrame;

import graph.LayeredGraphNode;
import processor.PseudoCodeNode;
import processor.PseudoCodeProcessor;

public class RandomProcessor extends PseudoCodeProcessor {

    private static final double STEP_OVER = 0.1;
    private static final double STEP_OUT = 0.1;
    private static final int ITERATIONS = 1000;
    
    public RandomProcessor(PseudoCodeNode start, LayeredGraphNode graph, JFrame view) {
        super(start, graph, view);
    }
    
    @Override
    public void run()
    {
        try {
            System.out.println( "Start Random Tests." );
            for( int i = 0; i < ITERATIONS; i++ )
            {
                int actions = 0;
                CodeStatus status = null;
                while( status != CodeStatus.FINISHED )
                {
                    if( Math.random() < STEP_OVER )
                        status = forwardStepOver();
                    else if( Math.random() < STEP_OUT )
                        status = forwardStepOut();
                    else
                        status = forwardStep();
                    actions++;
                }
                status = null;
                while( status != CodeStatus.FINISHED )
                {
                    if( Math.random() < STEP_OVER )
                        status = backwardStepOver();
                    else if( Math.random() < STEP_OUT )
                        status = backwardStepOut();
                    else
                        status = backwardStep();
                    actions++;
                }
                System.out.println( actions + " Actions done.");
                if( !controlStack.isEmpty() )
                    throw new IllegalStateException( "There are too manny Objects in the control Stack." );
                System.out.println( "Random Iteration " + i + " finished successfully." );
            }
        } catch (Exception e) {
            e.printStackTrace();
            return;
        }
    }
}
